#ifndef __BasicMechanism_h
#define __BasicMechanism_h

#include <string>
#include <vector>
#include "Engine.h"

class BasicMechanism {
    protected:
      std::string name;
      std::vector<Engine*> engines_line;
      int lineSize;
      std::string accessory;
  public:
      BasicMechanism(std::string name, int lineSize);
      std::string getName();
      int getLineSize();
      virtual void doJob(Engine* engine);
      Engine* getEngine();
      int getEnginesCount();
      void clearPointer();
      virtual void closeFile();
};

//----------------------------------------------------

class CylinderMechanism : public BasicMechanism {
  public:   
    CylinderMechanism(std::string name, int lineSize);
};

//----------------------------------------------------

class FilterMechanism : public BasicMechanism {
  public:   
    FilterMechanism(std::string name, int lineSize);
};

//----------------------------------------------------

class InjectionMechanism : public BasicMechanism {
  public:   
    InjectionMechanism(std::string name, int lineSize);
};

//----------------------------------------------------

//----------------------------------------------------

//----------------------------------------------------

//----------------------------------------------------

//----------------------------------------------------

//----------------------------------------------------

#endif
