#include "StatisticMechanism.h"
#include "BasicMechanism.h"
#include "Accessory.h"
#include "Engine.h"
using namespace std;

StatisticMechanism::StatisticMechanism(string nm, int lSize)
: BasicMechanism(nm, lSize) {
    name = nm;
    lineSize = lSize;
    didEngines = 0;
    badEngines = 0;
    outFile.open("output.txt", ofstream::out | ofstream::trunc);
    outFile << "Varikliu konvejeris pagamino: \n" << endl;
}

void StatisticMechanism::doJob(Engine* engine) {
    int bad = 0;
    didEngines++;
    outFile << "Variklis: " << engine->getName() << endl;
    outFile << "Dalys:" << endl;
    vector<Accessory*>::iterator access = engine->getAccessoriesBegin();
    
    for (; access != engine->getAccessoriesEnd(); access++) {
        if ( (*access)->getError() == true ) {
            outFile << "  " << (*access)->getName() << "        *** SU GEDIMAIS!" << endl;
            bad++;
        } else outFile << "  " << (*access)->getName() << endl;       
    }
    
    outFile << "---------------------" << endl;
    if (bad != 0) badEngines++;
    outFile << "                                       Statistika:" << endl;
    outFile << "                                         Pagamino varikliu: " << didEngines << endl;
    outFile << "                                         Varikliai su gedimais: " << badEngines << endl;
    outFile << "                                         Varikliai be gedimu: " << (didEngines-badEngines) << endl;
    outFile << "---------------------" << endl;
    delete engine;
}

void StatisticMechanism::closeFile() {
     outFile.close();
}
