#include <iostream>
#include <fstream>
#include "Conveyor.h"
#include "Engine.h"
#include "BasicMechanism.h"
#include "CylinderMechanism.h"
#include "InjectionMechanism.h"
#include "RadiatorMechanism.h"
#include "FilterMechanism.h"
#include "WiresMechanism.h"
#include "ScrewsMechanism.h"
#include "StatisticMechanism.h"
using namespace std;

bool jobIs(Conveyor* con) {
    for (int i = 0; i < (*con).getMechanismVectorSize() - 1; i++) {
        if ( (*con).getBasicMechanism(i)->getEnginesCount() > 0 ) 
            return true; 
    }
    return false;     
}

int main() {
    
    Conveyor* con = new Conveyor("Varikliu konvejeris");
    (*con).addMechanism(new BasicMechanism("Variklio modelis", 3));
    (*con).addMechanism(new CylinderMechanism("Cylindrai", 2));
    (*con).addMechanism(new InjectionMechanism("Ipurskimas", 3));
    (*con).addMechanism(new RadiatorMechanism("Radiatorius", 3));
    (*con).addMechanism(new FilterMechanism("Filtrai", 3));
    (*con).addMechanism(new WiresMechanism("Laidai", 3));
    (*con).addMechanism(new ScrewsMechanism("Varztai", 3));
    (*con).addMechanism(new StatisticMechanism("Statistika", 20));    
    
    ifstream inFile ("input.txt");
    string name;
    inFile >> name;
    int i, j;
    
    while (inFile.good()) {
          
        do {
        
            for (i = 0; i < (*con).getMechanismVectorSize(); i++) {
                if ( (i == 0) && (inFile.good()) ) {                 
                    j = (*con).getBasicMechanism(i)->getLineSize() - (*con).getBasicMechanism(i)->getEnginesCount();
                    
                    while ( (j > 0) && (inFile.good()) ) {
                        (*con).getBasicMechanism(i)->doJob(new Engine(name));     
                        j--;
                        inFile >> name;
                    }
                    
                } else {
                          if (i == 0) { i++; }
                          j = (*con).getBasicMechanism(i)->getLineSize() - (*con).getBasicMechanism(i)->getEnginesCount();
                      
                          while ( (j > 0) && ((*con).getBasicMechanism(i-1)->getEnginesCount() > 0) ) {
                              (*con).getBasicMechanism(i)->doJob( (*con).getBasicMechanism(i-1)->getEngine() );
                              (*con).getBasicMechanism(i-1)->clearPointer();
                              j--;
                          }
                      
                      }           
            } // for end
         
        } while (jobIs( con ) == true);    
    }
    inFile.close();
    (*con).getBasicMechanism(i-1)->closeFile();
}
